from sys import exit,setrecursionlimit
setrecursionlimit(1000000000)
n, m = map(int, input().split())
mat = [input() for i in range(n)]
vis = [[False]*m for i in range(n)]

def dfs(sx, sy):
    to_visit = [[sx,sy]]
    DX = [0,0,1,-1]
    DY = [-1,1,0,0]
    while to_visit:
        x,y = to_visit[-1]
        to_visit.pop()
        vis[x][y] = True
        comp[-1].append((x,y))
        for i in range(4):
            nx, ny = x+DX[i], y+DY[i]
            if 0<=nx<n and 0<=ny<m and mat[nx][ny] == '#' and not vis[nx][ny]:
                vis[nx][ny]=True
                to_visit.append([nx,ny])

def bounding_box(c):
    bb = [c[0][0], c[0][1], c[0][0], c[0][1]]
    for i, j in c:
        bb[0] = min(bb[0], i)
        bb[1] = min(bb[1], j)
        bb[2] = max(bb[2], i)
        bb[3] = max(bb[3], j)
    return bb

def is_eye(p):
    return len(p[0])==(p[1][2]-p[1][0]+1)*(p[1][3]-p[1][1]+1)

def is_nose(p):
    q = p[0]
    q.sort()
    idx=0
    if m%2==1:
        j=1
    else:
        j=2
    while idx+j-1<len(q):
        if idx != 0 and (q[idx][0]!=q[idx-1][0]+1 or q[idx][1]!=q[idx-1][1]-j+2):
            return False
        for k in range(j):
            if q[idx+k][0]!=q[idx][0] or q[idx+k][1]!=q[idx][1]+k:
                return False
        idx += j
        j += 2
    return idx == len(q)

def is_mouth(p):
    return p[1][0]==p[1][2]

def bad_edge():
    for i in range(n):
        if mat[i][0]=='#' or mat[i][-1]=='#':
            return True
    for i in range(m):
        if mat[0][i]=='#' or mat[-1][i]=='#':
            return True
    return False

def symm():
    for i in range(n):
        for j in range(m):
            if mat[i][j]!=mat[i][m-1-j]:
                return False
    return True

comp = []
for i in range(n):
    for j in range(m):
        if mat[i][j]=='#' and not vis[i][j]:
            comp.append([])
            dfs(i, j)

if len(comp) != 4:
    print(-1)
    exit()

comp = [(i, bounding_box(i)) for i in comp]
comp.sort(key = lambda x: x[1])
leye = comp[0]
reye = comp[1]
nose = comp[2]
mouth = comp[3]
if not (is_eye(leye) and is_eye(reye) and is_nose(nose) and is_mouth(mouth)):
    print(-1)
    exit()

if (leye[1][2]+1 >= nose[1][0] or reye[1][2]+1 >= nose[1][0]
        or nose[1][2]+1 >= mouth[1][0]):
    print(-1)
    exit()

if bad_edge() or not symm():
    print(-1)
    exit()

#print(leye, is_eye(leye))
#print(reye, is_eye(reye))
#print(nose, is_nose(nose))
#print(mouth, is_mouth(mouth))
print(leye[1][2]-leye[1][0]+1)
print(nose[1][2]-nose[1][0]+1)
print(mouth[1][3]-mouth[1][1]+1)
